/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: jtag_uart.h 6914 2013-01-30 06:40:51Z fsi-dankei $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СJTAG UARTѡ
 */

#ifndef TOPPERS_JTAG_UART_H
#define TOPPERS_JTAG_UART_H

#include "prc_sil.h"

/*
 *  ϡɥ
 */
/*
 *  쥸եå
 */
#define JTAG_UART_DATA_OFFSET    UINT_C(0x00)
#define JTAG_UART_CONTROL_OFFSET UINT_C(0x04)

/*
 *  쥸ӥå
 */
#define JTAG_UART_DATA_RVALID UINT_C(0x8000)
#define JTAG_UART_CONTROL_RIE UINT_C(0x01)
#define JTAG_UART_CONTROL_WIE UINT_C(0x02)
#define JTAG_UART_CONTROL_RIP UINT_C(0x04)
#define JTAG_UART_CONTROL_WIP UINT_C(0x08)
#define JTAG_UART_CONTROL_WSAPCE UINT_C(0xffff0000)

/*
 *  쥸ɥ쥹
 */
#define JTAG_UART_PORT1_CONTROL (JTAG_UART_PORT1_BASE + JTAG_UART_CONTROL_OFFSET)
#define JTAG_UART_PORT1_DATA    (JTAG_UART_PORT1_BASE + JTAG_UART_DATA_OFFSET)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͥ٥Ѵؿ(JTAG UART)
 */

LOCAL_INLINE void
nios2_dev_putc(char8 c)
{
	while ((sil_rew_iop((void *) (JTAG_UART_PORT1_CONTROL)) & JTAG_UART_CONTROL_WSAPCE) == 0U) {
		/* ¹Ԥ٤ʤ */
	}
	sil_wrw_iop((void *) (JTAG_UART_PORT1_DATA), (uint32) c);
}

/*
 *  serial.c ƤӽФؿ
 */

/*
 *  
 */
extern void InitHwSerial(void);

/*
 *  λ
 */
extern void TermHwSerial(void);

/*
 *  Хåϥɥ
 */
extern void RxSerialInt(uint8 character);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_JTAG_UART_H */
