/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_config.h 6861 2013-01-24 08:21:59Z shigihara $
 */

/*
 *		ץå¸⥸塼Nios2ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#include "nios2.h"
#include "vic.h"

/*
 *  顼åˡλ
 */
#define CHECK_STKSZ_ALIGN	4   /* åΥ饤ñ */
#define CHECK_FUNC_ALIGN	4   /* ؿΥ饤ñ */
#define CHECK_FUNC_NONNULL      /* ؿNULLå */
#define CHECK_STACK_ALIGN	4   /* åΰΥ饤ñ */
#define CHECK_STACK_NONNULL     /* åΰNULLå */

/*
 *	֥Υ
 */
#ifndef FUNCTION_ALIGN_SIZE
#define FUNCTION_ALIGN_SIZE 4
#endif /* FUNCTION_ALIGN_SIZE */

/*
 *  ֹ˴ؤ
 */
#define TMIN_INTNO UINT_C(0)
#define TMAX_INTNO UINT_C(31)
#define TNUM_INT   UINT_C(32)

#define call_errorhook(ercd, svcid)		stack_change_and_call_func_2((void *) &internal_call_errorhook, (ercd), (svcid))
#define call_shutdownhook(ercd)			stack_change_and_call_func_1((void *) &internal_call_shtdwnhk, ((uint32) (ercd)))

/*
 * ֹ椫顤IRCΤΥӥåȥѥޥ
 */
#define INTNO_BITPAT(intno)  ((uint32) 1 << (intno))

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno) (((InterruptNumberType) (TMIN_INTNO) <= (intno)) && ((intno) <= (InterruptNumberType) (TMAX_INTNO)))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  󥿥ƥѤΥåϥɥ쥹ޥ
 */
#define TOPPERS_OSTKPT(stk, stksz) ((StackType *) ((sint8 *) (stk) + (stksz)))

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 * 㳰ʳ/CPU㳰ˤΥͥȲΥ
 *
 * ƥȻȤΤ˻
 */
extern uint32		except_nest_cnt;

/*
 * OS߶ػ߻status.ILؤ
 */
extern const uint32	tmin_status_il;

/*
 *  ߽ǥμ¸
 */

/*
 *  ͥ٥ޥ¸ɽ(ɽ)Nios2¸ɽ(ɽ)Ѵ
 */
#define EXT_IPM(iipm)    (-((PriorityType) (iipm)))             /* ɽɽ */
#define INT_IPM(ipm)     ((uint32) ((PriorityType) (-(ipm))))   /* ɽɽ */

/*
 *  ߶ػ߾֤ؤΰܹ
 */
LOCAL_INLINE void
x_lock_all_int(void)
{
	set_status(current_status() & (~STATUS_PIE));
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("" ::: "memory");
}

/*
 *  ߶ػ߾֤β
 */
LOCAL_INLINE void
x_unlock_all_int(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("" ::: "memory");
	set_status(current_status() | STATUS_PIE);
}

/*
 *  OS߶ػ߾֤λ˳ͥ٥ޥ¸ѿ
 */
extern volatile uint32	saved_status_il;

/*
 *  x_nested_lock_os_int()ΥͥȲ
 *  νѲʤ褦volatile 
 */
extern volatile uint8	nested_lock_os_int_cnt;

/*
 *  OS߶ػ
 *  API¹Ի˸ƤӽФ
 *  ͥ٥ޥISR2ͥ٥ޥϰϤ⤤֤ǸƤӽФ
 *  ȤϤʤ(ISR1ƤӽФ뤳ȤϤʤ)
 *  ꥽status.IL0礭֤ǸƤӽФ뤿å
 *  status.ILͤsaved_status_il¸
 */
LOCAL_INLINE void
x_nested_lock_os_int(void)
{
	uint32 status;

	/*
	 *  ܤʤstatus.ILOSߤζػߥ٥ͥ٥ޥͤ¸
	 */
	if (nested_lock_os_int_cnt == 0U) {
		status = current_status();
		set_status((status & (~STATUS_IL)) | tmin_status_il);
		saved_status_il = status & STATUS_IL;
	}
	nested_lock_os_int_cnt++;

	Asm("" ::: "memory");
}

/*
 *  OS߲
 *  API¹Ի˸ƤӽФ
 *  ͥ٥ޥISR2ͥ٥ޥϰϤ⤤֤ǸƤӽФ
 *  ȤϤʤ(ISR1ƤӽФ뤳ȤϤʤ)
 */
LOCAL_INLINE void
x_nested_unlock_os_int(void)
{
	Asm("" ::: "memory");

	nested_lock_os_int_cnt--;

	/*
	 *  ֳ¦ʤͥ٥ޥ򹹿
	 */
	if (nested_lock_os_int_cnt == 0U) {
		set_status((uint32) ((current_status() & (~STATUS_IL)) | saved_status_il));
	}
}

/*
 *  SuspendOSInterrupts()ƤӽФOS߶ػ߾֤ؤΰܹ
 *  x_nested_lock_os_int()Ȥΰ㤤ϡISR1ƤӽФǽ뤿ᡤ
 *  status.ILOS߶ػ߻ͤ礭ISR1ƤӽФ줿Ȥơ
 *  ⤻꥿󤹤
 */
LOCAL_INLINE void
x_suspend_lock_os_int(void)
{
	uint32	status;
	uint32	status_il;

	status = current_status();
	status_il = status & STATUS_IL;

	/*
	 *  ƥ1 ISRƤФ줿ϲ⤷ʤ
	 */
	if (status_il <= tmin_status_il) {

		/*
		 *  ܤʤstatus.ILOSߤζػߥ٥ͥ٥ޥͤ¸
		 */
		if (nested_lock_os_int_cnt == 0U) {
			set_status((status & (~STATUS_IL)) | tmin_status_il);
			saved_status_il = status_il;
		}
		nested_lock_os_int_cnt++;

		Asm("" ::: "memory");
	}
}

/*
 *  ResumeOSInterrupts()ƤӽФOS߶ػ߾֤β
 *  x_nested_unlock_os_int()Ȥΰ㤤ϡISR1ƤӽФǽ뤿ᡤ
 *  status.ILOS߶ػ߻ͤ礭ISR1ƤӽФ줿Ȥơ
 *  ⤻꥿󤹤
 */
LOCAL_INLINE void
x_resume_unlock_os_int(void)
{
	uint32	status;
	uint32	status_il;

	Asm("" ::: "memory");

	status = current_status();
	status_il = status & STATUS_IL;

	/*
	 * ƥ1 ISRƤФ줿ϲ⤷ʤ
	 */
	if (status_il <= tmin_status_il) {

		nested_lock_os_int_cnt--;

		/*
		 *  ֳ¦ʤͥ٥ޥ򹹿
		 */
		if (nested_lock_os_int_cnt == 0U) {
			set_status((status & (~STATUS_IL)) | saved_status_il);
		}
	}
}


/*
 *  (ǥ)ͥ٥ޥ
 *
 *  OSǤϼΩ
 *    * OS߶ػ߾֤ǸƤӽФ
 *    * OS߶ػ߻ͥ٤⤤ͤϻꤵʤ
 */
LOCAL_INLINE void
x_set_ipm(PriorityType intpri)
{
	ASSERT(nested_lock_os_int_cnt > 0U);
	saved_status_il = (INT_IPM(intpri) << STATUS_IL_OFFSET);
}

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  OSǤϼΩ
 *    * OS߶ػ߾֤ǸƤӽФ
 */
LOCAL_INLINE PriorityType
x_get_ipm(void)
{
	ASSERT(nested_lock_os_int_cnt > 0U);
	return(EXT_IPM((saved_status_il >> STATUS_IL_OFFSET)));
}

/*
 *  ׵饤°
 */
extern void x_config_int(InterruptNumberType intno, AttributeType intatr, PriorityType intpri);

/*
 *  ߥϥɥɬפIRC
 */
LOCAL_INLINE void
i_begin_int(InterruptNumberType intno)
{

}

/*
 *  ߥϥɥνиɬפIRC
 */
LOCAL_INLINE void
i_end_int(InterruptNumberType intno)
{

}

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);

extern void prc_hardware_initialize(void);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatch ϡƥȤƤӽФ줿ӥ
 *  ǡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡߶ػ߾֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatch ϡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void			*sp;        /* åݥ */
	FunctionRefType	pc;         /* ץ५ */
} TSKCTXB;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ
 */
extern void start_r(void);

#define activate_context(p_tcb) do {									  \
		(p_tcb)->tskctxb.sp = (void *) ((char8 *) ((p_tcb)->p_tinib->stk) \
										+ (p_tcb)->p_tinib->stksz);		  \
		(p_tcb)->tskctxb.pc = (FunctionRefType) &start_r;				  \
} while (0)

/* ηϥϡɥ륵uint32ˤƱ */
extern void stack_change_and_call_func_1(void *func, uint32 arg1);

extern void stack_change_and_call_func_2(void *func, uint8 arg1, uint8 arg2);

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_CONFIG_H_ */
