/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_support.S 6900 2013-01-29 05:10:15Z fsi-dankei $
 */

/*
 *		åȰ¸
 */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* ̵ޥ */
#define CAST(type, val)		(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "offset.h"

/*
 *  ߶ػߥޥ
 */
.macro LOCK_ALL_INT sc_reg1, sc_reg2
	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_PIE
	and   \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
.endm

/*
 *  ߶ػ߲ޥ
 */
.macro UNLOCK_ALL_INT sc_reg
	rdctl \sc_reg, status
	ori   \sc_reg, \sc_reg, %lo(STATUS_PIE)
	wrctl status, \sc_reg
.endm

/*
 *  OS߶ػߥޥ
 *  ͥȤΰֳ¦ǸƤӽФ뤳ȤꤷƤ
 */
.macro OUTER_LOCK_OS_INT sc_reg1, sc_reg2
	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_IL
	and   \sc_reg1, \sc_reg1, \sc_reg2
	ldw   \sc_reg2, %gprel(tmin_status_il)(gp)
	or    \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
	movi  \sc_reg1, 1
	stb   \sc_reg1, %gprel(nested_lock_os_int_cnt)(gp)
	stw   zero, %gprel(saved_status_il)(gp)
.endm

/*
 *  OS߶ػ߲ޥ
 *  ͥȤΰֳ¦ǸƤӽФ뤳ȤꤷƤ
 */
.macro OUTER_UNLOCK_OS_INT sc_reg1, sc_reg2
	stb   zero, %gprel(nested_lock_os_int_cnt)(gp)
	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_IL
	and   \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
.endm

 /*
  * å : ץå
  */
.macro PUSH reg
	addi  sp, sp, -4
	stw   \reg, 0(sp)
.endm

 /*
  * å : ݥå
  */
.macro POP reg
	ldw   \reg, 0(sp)
	addi  sp, sp, 4
.endm

/*
 *  㳰ȥ
 *  ץåξ֤ϡ
 *    status.PIEꥢ߶ػ
 *    status.IL㳰ȯ
 *    estatus㳰ȯstatusƤäƤ
 */
	.set noat
	.section .exceptions, "xa"
	.global exception_entry
	.balign  FUNCTION_ALIGN_SIZE
exception_entry:

	/*
	 *  TrapȽ
	 */
check_trap:
	ldw   et, -4(ea)               /* 㳰Ф̿ */
	xorhi et, et, 0x003b           /*  16bit             */
	xori  et, et, 0x683a           /*  16bit             */
	beq   et, zero, trap_handler   /* trap̿ΥХʥ 0x003b683a */

	/*
	 *  㳰ȥ
	 */
exception:
	/*
	 *  ƥȤ¸
	 */
	addi  sp, sp, -72    /* 쥸¸ */
	stw   at,   0(sp)
	stw   r2,   4(sp)
	stw   r3,   8(sp)
	stw   r4,  12(sp)
	stw   r5,  16(sp)
	stw   r6,  20(sp)
	stw   r7,  24(sp)
	stw   r8,  28(sp)
	stw   r9,  32(sp)
	stw   r10, 36(sp)
	stw   r11, 40(sp)
	stw   r12, 44(sp)
	stw   r13, 48(sp)
	stw   r14, 52(sp)
	stw   r15, 56(sp)
	stw   ra,  60(sp)
	stw   ea,  64(sp)
	rdctl et,  estatus
	stw   et,  68(sp)

	/*
	 *  ץƥեåOS٥Ǽ¹Ԥ뤿OS߶ػ߾֤ˤ
	 *  OS߶ػ߾֤㳰ȯǽ뤿ᡤͥȴԤ
	 *  ISR1¹Իȯϡͥ٥ޥOS߶ػ߾֤⤤ᡤ
	 *  status.ILѹʤ
	 *  㳰ϼξȯ
	 *   ISR1¹Ծ֤ȯ
	 *   ISR1¹Ծְʳȯ
	 *    OS߲֤ȯ
	 *    OS߶ػ߾֤ȯ
	 */

	/*
	 *  ISR1¹Ծ֤ȯϲԤʤ
	 *  OS߶ػ߾֤ILͤstatus.ILͥ٤ʤISR1㳰ȯ
	 *  r2r7ݻơåݥ󥿤ؤȽˤ
	 */
	rdctl r4,status
	andi  r7, r4, STATUS_IL
	ldw   r2, %gprel(tmin_status_il)(gp)
	bltu  r2, r7, exception_1

	/*
	 *  ISR1¹Ծְʳȯ
	 */
	ldbu  r3, %gprel(nested_lock_os_int_cnt)(gp)
	addi  r1, r3, 1
	stb   r1, %gprel(nested_lock_os_int_cnt)(gp)

	/*
	 *  OS߶ػ߾֤ȯstatusѹʤ
	 */
	bne   zero, r3, exception_1

	/*
	 *  OS߲֤ȯ
	 *  OS߶ػ߾֤Ȥ
	 *  㳰νиΥ꥿(eret)ˤstatus.IL㳰뤿ᡤ
	 *  saved_status_ilˤ¸ʤ
	 */
	movi  r3, ~STATUS_IL
	and   r3, r4, r3
	or    r3, r3, r2
	wrctl status, r3

exception_1:
	/*
	 *  CPU㳰ֹ, badaddr
	 *  ȯѹΤǳ߶ػ߲˼
	 */
	rdctl r5, exception
	rdctl r8, badaddr

	/*
	 *  㳰ȯ߶ػ߾֤Ǥʤ߶ػ߲֤Ȥ
	 */
	rdctl r3, estatus
	andi  r3, r3, STATUS_PIE
	beq   r3, zero, exception_2

	UNLOCK_ALL_INT r1

exception_2:
	/*
	 *  ͥ뵯ưƤʤ˵CPU㳰ϡ̵¥롼פ
	 */
	ldb   r3, %gprel(kerflg)(gp)  /* kerflgFALSEʤ̵¥롼 */
	beq   zero, r3, infinity_loop

	/*
	 *  ߡ㳰ΥͥȲΥ󥯥
	 */
	ldw   r3, %gprel(except_nest_cnt)(gp)
	addi  r4, r3, 1
	stw   r4, %gprel(except_nest_cnt)(gp)

	mov   r4, sp        /* r4sp */

	/*
	 *  ¿ųߤȽ
	 */
	bltu  zero, r3, exception_3

	/*
	 *  ISR1¹Ծ֤ȯϥåݥ󥿤ؤʤ
	 *  r2tmin_status_ilr7STATUS_ILݻƤ
	 */
	bltu  r2, r7, exception_3

	/*
	 *  åݥ󥿤ؤ
	 */
	ldw   r2, %gprel(_ostkpt)(gp)
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸ */
	mov   sp, r2        /* åݥ󥿤ؤ */

exception_3:

#ifdef CFG_USE_PROTECTIONHOOK
	/* nios2_cpu_exp_*򤹤륹ڡ */
	addi  sp, sp, -16

	/* nios2_cpu_exp_no */
	ldw   r6, %gprel(nios2_cpu_exp_no)(gp)
	stw   r6, 12(sp)

	/*
	 *  exception / 4㳰ֹ
	 */
	andi  r5, r5, ((1 << 7) - 1)
	srli  r5, r5, 2

	stw   r5, %gprel(nios2_cpu_exp_no)(gp)

	/* nios2_cpu_exp_pc */
	ldw   r6, %gprel(nios2_cpu_exp_pc)(gp)
	stw   r6, 8(sp)

	/*
	 *  㳰ȯPC - 4
	 *  r4späƤ
	 */
	ldw   r6, 64(r4)
	addi  r6, r6, -4
	stw   r6, %gprel(nios2_cpu_exp_pc)(gp)

	/* nios2_cpu_exp_bad_addr */
	ldw   r6, %gprel(nios2_cpu_exp_bad_addr)(gp)
	stw   r6, 4(sp)

	stw   r8, %gprel(nios2_cpu_exp_bad_addr)(gp)

	/* nios2_cpu_exp_bad_sp */
	ldw   r6, %gprel(nios2_cpu_exp_sp)(gp)
	stw   r6, 0(sp)

	/* r4späƤ */
	stw   r4, %gprel(nios2_cpu_exp_sp)(gp)
#endif /* CFG_USE_PROTECTIONHOOK */

	/*
	 *  CPU㳰ȯ硤OSE_OS_PROTECTION_EXCEPTIONѥ᡼Ȥ
	 *  ץƥեåƤӽФ
	 */
	movi  r4,  E_OS_PROTECTION_EXCEPTION 	/* call_protectionhk_mainΰ */
	call  call_protectionhk_main		/* ץƥեåθƤӽФ */

#ifdef CFG_USE_PROTECTIONHOOK
	/* nios2_cpu_exp_no */
	ldw   r6, 12(sp)
	stw   r6, %gprel(nios2_cpu_exp_no)(gp)

	/* nios2_cpu_exp_pc */
	ldw   r6, 8(sp)
	stw   r6, %gprel(nios2_cpu_exp_pc)(gp)

	/* nios2_cpu_exp_bad_addr */
	ldw   r6, 4(sp)
	stw   r6, %gprel(nios2_cpu_exp_bad_addr)(gp)

	/* nios2_cpu_exp_bad_sp */
	ldw   r6, 0(sp)
	stw   r6, %gprel(nios2_cpu_exp_sp)(gp)

	/* nios2_cpu_exp_*򤷤ڡ᤹ */
	addi  sp, sp, 16
#endif /* CFG_USE_PROTECTIONHOOK */

ret_exc:
	/*
	 *  ץƥեåOS߶ػ߾֤Ǽ¹Ԥ
	 *  ret_int_1  eret  esatus -> status ǲ
	 */

	/*
	 *  ߡ㳰ΥͥȲΥǥ
	 */
	ldw   r3, %gprel(except_nest_cnt)(gp)
	addi  r3, r3, -1
	stw   r3, %gprel(except_nest_cnt)(gp)

	/*
	 *  OS߶ػ߾֤β
	 */
	/*
	 *  ISR1¹Ծ֤ȯ
	 *  (1)åݥ󥿤ؤ򤷤ʤ
	 *  (2)OS߶ػ߾֤β򤷤ʤ
	 *  OS߶ػ߾֤ILͤstatus.ILͥ٤ʤISR1ȯ㳰
	 *  r4statusݻret_exc_2Ǥ
	 */
	rdctl r4,status
	andi  r5, r4, STATUS_IL
	ldw   r6, %gprel(tmin_status_il)(gp)
	bltu  r6, r5, ret_exc_2

	/*
	 *  ͥȲ1ʾʤ߸ISRʤ㳰ȯ
	 *  åݥ󥿤ؤʤ
	 */
	bne  zero, r3, ret_exc_1

	/*
	 *  褬ʤ᥹å᤹
	 */
	ldw   r2, 0(sp)              /* åݥ󥿤᤹    */
	mov   sp, r2

ret_exc_1:
	/*
	 *  ISR1¹Ծְʳȯ硤OS߶ػ߾֤β
	 *  㳰Υ꥿ˤstatus.IL㳰뤿ᡤstatus.ILιϤʤ
	 */
	ldbu  r3, %gprel(nested_lock_os_int_cnt)(gp)
	addi  r3, r3, -1
	stb   r3, %gprel(nested_lock_os_int_cnt)(gp)

	/*
	 *  㳰ȯ
	 *  ret_int_1 ߶ػ߾֤ǸƤӽФɬפ
	 */
ret_exc_2:
	andi  r4, r4, STATUS_PIE		/* statusPIEĤ */
	ldw   r1, 68(sp)				/* CPU㳰ȯstatus(estatus) */
	movi  r2, ~STATUS_PIE
	and   r1, r1, r2				/* etatusPIE򥯥ꥢ */
	or    r1, r1, r4				/* estatusPIEstatusPIEˤ */
	stw   r1, 68(sp)

	LOCK_ALL_INT  r1, r2
	br ret_int_1

	/*
	 *  ͥ뵯ưƤʤ˵CPU㳰̵¥롼
	 */
infinity_loop:
	br infinity_loop

	/*
	 *  ߥȥ
	 *  ٥ơ֥뤫 Os_Lcfg.c Ƴߤγߥȥ
	 *  饸פet˳ֹ椬¸줿֤Ǽ¹Ԥ
	 *  ץåξ֤ϡ
	 *    status.PIEꥢ߶ػ
	 *    status.IL˼դߤγͥ٤å
	 *    estatus˳statusƤäƤ
	 */
	.global interrupt
	.balign  FUNCTION_ALIGN_SIZE
interrupt:
	addi  ea, ea, -4     /* Ϥǥ */
	addi  sp, sp, -72    /* 쥸¸ */
	stw   at,   0(sp)
	stw   r2,   4(sp)
	stw   r3,   8(sp)
	stw   r4,  12(sp)
	stw   r5,  16(sp)
	stw   r6,  20(sp)
	stw   r7,  24(sp)
	stw   r8,  28(sp)
	stw   r9,  32(sp)
	stw   r10, 36(sp)
	stw   r11, 40(sp)
	stw   r12, 44(sp)
	stw   r13, 48(sp)
	stw   r14, 52(sp)
	stw   r15, 56(sp)
	stw   ra,  60(sp)
	stw   ea,  64(sp)
	mov   r4,  et        /* װr4˰ư */
	rdctl et, estatus
	stw   et,  68(sp)

	/*
	 *  ¿ųߤȽ
	 */
	ldw   r3, %gprel(except_nest_cnt)(gp)

	/*
	 *  ߡ㳰ΥͥȲΥ󥯥
	 */
	addi  r5, r3, 1
	stw   r5, %gprel(except_nest_cnt)(gp)

	bltu  zero, r3,  interrupt_1		/* ͥȤƤϥå̵ */

	/*
	 *  ˳
	 *  åݥ󥿤ؤ
	 */
	ldw   r2, %gprel(_ostkpt)(gp)
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸     */
	mov   sp, r2        /* åݥ󥿤ؤ */

interrupt_1:
	UNLOCK_ALL_INT r1

	/*
	 *  åΥХեå
	 */
#ifdef CFG_USE_STACKMONITORING

	/*
	 *  ¿ųߤξϥåΥå˥󥰤Ԥʤ
	 */
	bltu  zero, r3,  int_nested

	/*
	 *  åݥ󥿥å
	 */
	ldw   r7,   0(sp)								/* ¸åݥ󥿤 */
	ldw   r6,   %gprel(p_runtsk)(gp)				/* ֥åƬɥ쥹 */
	ldw   r6,   TCB_p_tinib(r6)						/* ֥åƬɥ쥹 */
	ldw   r6,   TINIB_stk(r6)						/* åƬɥ쥹 */
	bleu  r7,   r6,  stack_monitoring_error_isr		/* åݥ <= åƬξNG  */
	/*
	 *  ޥåʥСå
	 */
	ldw   r8,  0(r6)								/* åƬɥ쥹ޥåΰͼ */
	movia r6,  STACK_MAGIC_NUMBER					/* ޥåʥСμ */
	/*
	 *  ޥåʥС̤˲ʤ顤߽
	 *  ˳硤ߥååʤ
	 */
	beq   r8,  r6,  stack_monitoring_exit
	br    stack_monitoring_error_isr				/* åޥåʥС˲NG  */

	/*
	 *  ¿ųߤξ
	 */
int_nested:
	/*
	 *  ߥåΥХեå
	 */
	/*
	 *  åݥ󥿥å
	 */
	ldw   r6,   %gprel(_ostk)(gp)		/* ߥåƬɥ쥹 */
	bleu  sp,   r6,  stack_monitoring_error_isr	/* åݥ <= åƬξNG  */
	/*
	 *  ޥåʥСå
	 */
	ldw   r7,   0(r6)							/* ޥåΰͼ */
	movia r6,   STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	bne   r7,   r6, stack_monitoring_error_isr	/* ޥåʥС */
stack_monitoring_exit:
#endif /* CFG_USE_STACKMONITORING */

	/*
	 *  callevel_stat ¸
	 */
	ldh   r3, %gprel(callevel_stat)(gp)
	PUSH  r3

	/*
	 *  callevel_stat 
	 */
	ori   r6, r3, TCL_ISR2
	sth   r6, %gprel(callevel_stat)(gp)

	/*
	 *  p_runisr ¸
	 */
	ldw   r3, %gprel(p_runisr)(gp)
	PUSH  r3

	/*
	 *  p_runisr 
	 */
	movia r2, isr_p_isrcb_tbl
	slli  r3, r4, 2                 /* ֹ4ܤƥեåȤ  */
	add   r2, r2, r3
	ldw   r5,0(r2)
	stw   r5, %gprel(p_runisr)(gp)

	/*
	 *  ߥϥɥΥɥ쥹ɤ߹
	 */
	movia r2, isr_tbl
	add   r2, r2, r3
	ldw   r6, 0(r2)

	/*
	 *  ߥϥɥƤӽФ
	 */
	callr r6

	/*
	 *  ߥåΥХեå
	 *  ߤäåݥ󥿤äϤʤΤǡ
	 *  ޥåʥСåΤ߼»
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ޥåʥСå
	 */
	ldw   r6, %gprel(_ostk)(gp)				/* ߥåƬɥ쥹 */
	ldw   r7, 0(r6)								/* ޥåΰͼ */
	movia r6, STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	bne   r7, r6, stack_monitoring_error_isr	/* ޥåʥС */
#endif /* CFG_USE_STACKMONITORING */

	/*
	 *  ISR2λå
	 */
	call  exit_isr2

	/*
	 *  p_runisr 
	 */
	POP   r3
	stw   r3, %gprel(p_runisr)(gp)

	/*
	 *  callevel_stat 
	 */
	POP   r3
	sth   r3, %gprel(callevel_stat)(gp)

/*
 *  ߥϥɥи
 */
ret_int:
	/*
	 *  except_nest_cntȥåڤؤδ֤OS߶ػߤˤ
	 *  ɬפ
	 *  衤ؤΥ꥿󤫡ٱǥѥåʬ
	 *  ؤΥ꥿ˤߤɬפǤꡤٱǥѥåˤ
	 *  ͥȴOS߶ػߤˤɬפ뤿ᡤǤϰö߶
	 *  ߤȤ
	 */
	LOCK_ALL_INT  r1, r2

	/*
	 *  ߡ㳰ΥͥȲΥǥ
	 */
	ldw   r3, %gprel(except_nest_cnt)(gp)
	addi  r3, r3, -1
	stw   r3, %gprel(except_nest_cnt)(gp)

	/*
	 *  ͥȲ0ʤ顤߸
	 */
	beq  zero, r3, ret_int_task

	/*
	 *  ISR2ߤΥ꥿ϳ߸
	 *  ISR2Ǥ뤿᤽Τޤޥ꥿
	 */
	br    ret_int_1

	/*
	 *  ߸ξ
	 */
ret_int_task:
	ldw   r2, 0(sp)              /* åݥ󥿤᤹    */
	mov   sp, r2

	/*
	 *  褬ξ硤ǥѥåɬפ뤫å
	 */
	ldw   r4, %gprel(p_runtsk)(gp)
	ldw   r5, %gprel(p_schedtsk)(gp)
	beq   r4, r5, ret_int_1      /* ǥѥåɬפʤг߸ */

	/*
	 *  Ǥϡ褬Ǥꡤåϡå
	 *  å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 *  ߤػߤ֤ȤʤäƤ
	 */

	/*
	 *  OS߶ػ߾֤˰ܹԤ
	 *
	 *  λOS߶ػ߾֤ȤΤϡdispatcher¹Ԥݤ
	 *  OS߶ػ߾֤ˤʤäƤɬפ뤿Ǥ
	 *
	 *  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤISR1ʳγߤƶػߤ
	 */
	OUTER_LOCK_OS_INT  r1, r2
	/* ret_int ߶ػ߾֤Ȥ */
	UNLOCK_ALL_INT r1

	/*
	 *  r4ˤp_runtskäƤ
	 */
	addi  sp,   sp, -36                /* ĤΥ쥸¸ */
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw   fp,  32(sp)
	stw   sp,  TCB_sp(r4)         /* åTCB¸ */
	movia r2,  ret_int_r          /* ¹ԺƳϤTCB¸   */
	stw   r2,  TCB_pc(r4)
	br    dispatcher

	/*
	 *  ߡ㳰ǥƥ¸롼
	 */
ret_int_r:
	ldw   r16,  0(sp)       /* 쥸 */
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw   fp,  32(sp)
	addi  sp, sp, 36

	/*
	 *  ץ꥿եåDisableAllInterrupts()򤷤ϡ
	 *  estatusSTATUS_PIEȿǤ
	 */
	rdctl r2, status
	andi  r2, r2, STATUS_PIE
	ldw   r1, 68(sp)
	movi  r3, %lo(~STATUS_PIE)
	and   r1, r1, r3
	or    r1, r1, r2
	stw   r1, 68(sp)

	/*
	 *  esatus Ȥ߶ػߤȤ
	 */
	LOCK_ALL_INT  r1, r2

	OUTER_UNLOCK_OS_INT  r1, r2

	/*
	 *  ߤ롼
	 *  estatusѤ뤿߶ػ߾֤ǸƤӽФȡ
	 *  ߶ػ߾֤ϡeretˤ
	 *  eret  estatus -> status Ȥʤ뤿ᡤILϸ͡PIEϳߵ
	 *  ꤵ
	 */
ret_int_1:
	/*
	 *  쥸
	 */
	ldw   at,   0(sp)
	ldw   r2,   4(sp)
	ldw   r3,   8(sp)
	ldw   r4,  12(sp)
	ldw   r5,  16(sp)
	ldw   r6,  20(sp)
	ldw   r7,  24(sp)
	ldw   r8,  28(sp)
	ldw   r9,  32(sp)
	ldw   r10, 36(sp)
	ldw   r11, 40(sp)
	ldw   r12, 44(sp)
	ldw   r13, 48(sp)
	ldw   r14, 52(sp)
	ldw   r15, 56(sp)
	ldw   ra,  60(sp)
	ldw   ea,  64(sp)
	ldw   et,  68(sp)
	wrctl estatus, et
	addi  sp, sp, 72
	eret

	/*
	 *  Trapϥɥ
	 */
trap_handler:
	eret

/*
 *  ǥѥå
 */
	.global dispatch
	.balign  FUNCTION_ALIGN_SIZE
dispatch:
	/*
	 *  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  
	 */
	addi  sp, sp, -40                /* 쥸¸ */
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw   fp,  32(sp)
	stw   ra,  36(sp)
	ldw   r4,  %gprel(p_runtsk)(gp) /* r4 <- runtsk              */
	stw   sp,  TCB_sp(r4)           /* åTCB¸ */
	movia r5,  dispatch_r			/* ¹ԳϤ¸        */
	stw   r5,  TCB_pc(r4)           /* ¹ԺƳϤTCB¸   */

#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ¹楿ΥåΥХեå
	 */
	/*
	 *  åݥ󥿥å
	 */
	ldw   r6,  %gprel(p_runtsk)(gp)				/* ֥åƬɥ쥹 */
	ldw   r6,  TCB_p_tinib(r6)					/* ֥åƬɥ쥹 */
	ldw   r6,  TINIB_stk(r6)					/* åƬɥ쥹 */
	bleu  sp,  r6,  stack_monitoring_error		/* åݥ <= åƬξNG  */
	/*
	 * ޥåʥСå
	 */
	ldw   r7,  0(r6)							/* åƬɥ쥹ޥåΰͼ */
	movia r6,  STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	bne   r7,  r6,  stack_monitoring_error		/* ޥåʥС */
#endif /* CFG_USE_STACKMONITORING */

	br    dispatcher

dispatch_r:
	ldw   r16,  0(sp)               /* 쥸 */
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw   fp,  32(sp)
	ldw   ra,  36(sp)
	addi  sp, sp, 40
	ret

/*
 *  ǥѥåư
 */
	.global start_dispatch
	.balign  FUNCTION_ALIGN_SIZE
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 *  ǸƤӽФ롥ޤsp󥿥ƥѥåݥ
	 *  ξ֤ǸƤӽФ뤳ȤꤷƤ
	 *
	 *  dispatcherϡOS߶ػ߾֤ǸƤӽФ
	 */
	/* OS߶ػ߾ */
	OUTER_LOCK_OS_INT r1, r2
	/* ߶ػ߲֤ */
	UNLOCK_ALL_INT  r1
	br    dispatcher_0

	/*
	 *  ߤΥƥȤΤƤƥǥѥå
	 */
	.global exit_and_dispatch
	.balign  FUNCTION_ALIGN_SIZE
exit_and_dispatch:
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ¹楿ΥåΥХեå
	 */
	/*
	 *  åݥ󥿥å
	 */
	ldw   r6,  %gprel(p_runtsk)(gp)				/* ֥åƬɥ쥹 */
	ldw   r6,  TCB_p_tinib(r6)					/* ֥åƬɥ쥹 */
	ldw   r6,  TINIB_stk(r6)					/* åƬɥ쥹 */
	bleu  sp,  r6,  stack_monitoring_error		/* åݥ <= åƬξNG  */
	/*
	 *  ޥåʥСå
	 */
	ldw   r7,  0(r6)							/* åƬɥ쥹ޥåΰͼ */
	movia r6,  STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	bne   r7,  r6,  stack_monitoring_error		/* ޥåʥС */
#endif /* CFG_USE_STACKMONITORING */
	/* ǥѥåΡdispatcherˤ */

dispatcher:
	/*
	 *  PostTaskHookθƤӽФ
	 */
#ifdef CFG_USE_POSTTASKHOOK
	movia r2, PostTaskHook
	beq   r2, zero, dispatcher_0
posttaskhook_call:
	movia r4, call_posttaskhook
	call  stack_change_and_call_func_1
#endif /* CFG_USE_POSTTASKHOOK */

dispatcher_0:
	/*
	 *  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ
	 */
#ifdef LOG_DSP_ENTER
	ldw   r4,  %gprel(p_runtsk)(gp)
	beq   r4, zero, 1f
	call  log_dsp_enter
1:
#endif /* LOG_DSP_ENTER */

	ldh   r5, %gprel(callevel_stat)(gp)
	andi  r4, r5, TSYS_DISALLINT
	beq   r4, zero, dispatcher_1

	andi  r5, r5, %lo(~TSYS_DISALLINT)
	stw	  r5, %gprel(callevel_stat)(gp)
	UNLOCK_ALL_INT    r2    /* ߶ػ߲֤ */

	/*
	 *  㳰ʳ/CPU㳰ˤΥͥȲstart_dispatch䡤dispatcher_3:
	 *  褿'1'ȤʤäƤ뤿ᡤåڤ괹塤
	 *  '0'˽
	 */
dispatcher_1:
	ldw   r5,   %gprel(p_schedtsk)(gp) /* r5 <- schedtsk              */
	stw   r5,   %gprel(p_runtsk)(gp)   /* schedtsk  runtsk        */
	beq   r5,   zero, dispatcher_3     /* schedtsk뤫            */
	ldw   sp,   TCB_sp(r5)             /* TCB饿å */
	stw   zero, %gprel(except_nest_cnt)(gp) /* 㳰ͥȲ'0' */

#ifdef LOG_DSP_LEAVE
	ldw   r4,  %gprel(p_runtsk)(gp)
	call  log_dsp_leave
#endif /* LOG_DSP_LEAVE */

#ifdef CFG_USE_PRETASKHOOK
	movia r2, PreTaskHook
	beq   r2, zero, dispatcher_2
pretaskhook_call:
	movia r4, call_pretaskhook
	call  stack_change_and_call_func_1
#endif /* CFG_USE_PRETASKHOOK */

dispatcher_2:
	ldw   r5, %gprel(p_runtsk)(gp)
	ldw   r5, TCB_pc(r5)			/* TCB ¹ԺƳϤ   */
	jmp   r5

dispatcher_3:
	/*
	 *  OS߶ػ߾֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 *  򤹤
	 *
	 *  󥿥ƥȤڤؤsp󥿥ƥ
	 *  ѥåݥ󥿡except_nest_cnt1)ΤϡOS߶ػ߲
	 *  ȯ߽ˤɤΥåȤȤβ
	 *  ȡߥϥɥǤΥǥѥåɻߤȤ2Ĥΰ
	 *  ̣
	 */
	ldw   r2, %gprel(_ostkpt)(gp)	/* 󥿥ƥѤΥåɤ߹ */
	mov   sp, r2							/* åݥ󥿤ؤ */
	movi  r5, TCL_ISR2						/* callevel_stat ISR2 */
	sth   r5, %gprel(callevel_stat)(gp)
	movi  r5, 1								/* except_nest_cnt 1 */
	stw   r5, %gprel(except_nest_cnt)(gp)

	/*
	 *  OS߶ػ߲֤
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤ
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *
	 *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫GetTaskIDƤӽ
	 *  ݤưͤ˹פʤʤ
	 */
	OUTER_UNLOCK_OS_INT r1, r2

	nop
	nop
	nop
	nop

	/*
	 *  OS߶ػ߾֤
	 *  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤISR1ʳγߤƶػߤ
	 *  å󥿥ƥȤΥåѤƤ뤿ᡤexcept_nest_cntϡ
	 *  '1'ΤޤޤȤ
	 */
	OUTER_LOCK_OS_INT r1, r2
	movi  r5, TCL_TASK
	sth   r5, %gprel(callevel_stat)(gp)		/* callevel_stat TASK */
	br    dispatcher_1

	/*
	 *  åХեν
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  åХեץƥեåƤӽФ
	 *  å򹹤˲ʤᡤߥåνͤѤ
	 */
stack_monitoring_error_isr:
	OUTER_LOCK_OS_INT r1, r2					/* ISR褿OS߶ػߤˤʤäƤʤ */

stack_monitoring_error:
	ldw   r2, %gprel(except_nest_cnt)(gp)		/* _ostkptȤexcept_nest_cnt򥤥󥯥Ȥ */
	addi  r2, r2, 1
	stw   r2, %gprel(except_nest_cnt)(gp)
	ldw   sp,  %gprel(_ostkpt)(gp)		/* å򹹤˲ʤᡤߥåνͤѤ */

	movi  r4,  E_OS_STACKFAULT					/* ץƥեåΰ */
	call  call_protectionhk_main				/* ץƥեåƤӽФ */
	/*
	 *  ץƥեåäƤʤ
	 */
#endif /* CFG_USE_STACKMONITORING */

/*
 *  ϻ
 *
 *  dispatcherƤӽФ
 */
	.text
	.global start_r
	.balign  FUNCTION_ALIGN_SIZE
start_r:

	/*
	 *  OS߶ػ߲˸ͥ(TCB.curpri)¹ͥ(TINIB.exepri)
	 *  ѹ(꥽)
	 */
	ldw   r4, %gprel(p_runtsk)(gp)		/* r4 <- runtsk */
	ldw   r6, TCB_p_tinib(r4)
	ldb   r5, TINIB_exepri(r6)			/* TINIB.exepri -> TCB.curpri */
	stb   r5, TCB_curpri(r4)

	/*
	 *  OS߶ػ߲֤
	 *  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤͭʳߤƵĤ
	 */
	OUTER_UNLOCK_OS_INT r2, r3

	/*
	 *  λݸԤ褦
	 *  ꥢɥ쥹exit_task
	 */
	movia ra, exit_task					/* ra(ϡ <- exit_task */

	ldw   r3, TCB_p_tinib(r4)			/* r3  <- p_runtsk->p_tinib */
	ldw   r2, TINIB_task(r3)			/* r2 <- μ¹ */
	jmp   r2							/* μ¹Գ */

	.global stack_change_and_call_func_1
	.global stack_change_and_call_func_2
	.balign  FUNCTION_ALIGN_SIZE
stack_change_and_call_func_1:
stack_change_and_call_func_2:

	PUSH  ra

	ldw   r2, %gprel(except_nest_cnt)(gp)
	addi  r3, r2, 1
	stw   r3, %gprel(except_nest_cnt)(gp)
	bne   zero, r2, 1f

	ldw   r2, %gprel(_ostkpt)(gp)
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸     */
	mov   sp, r2        /* åݥ󥿤ؤ */
1:

	mov   r2, r4
	mov   r4, r5
	mov   r5, r6
	callr r2

	ldw   r2, %gprel(except_nest_cnt)(gp)
	subi  r2, r2, 1
	stw   r2, %gprel(except_nest_cnt)(gp)
	bne   zero, r2, 1f

	ldw   sp, 0(sp)     /* åݥ󥿤     */
1:
	POP   ra
	ret
