/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: uart.c 6913 2013-01-30 06:39:28Z fujitsu-wada $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СUARTѡ
 */

#include "Os.h"
#include "target_serial.h"
#include "Os_Lcfg.h"

/* ؿΥץȥ */
LOCAL_INLINE boolean uart_getready(void);
LOCAL_INLINE uint8 uart_getchar(void);

/*
 *  ʸå
 */
LOCAL_INLINE boolean
uart_getready(void)
{
	return((sil_rew_iop((void *) UART_STATUS) & UART_STATUS_RRDY) != 0U);
}

/*
 *  ʸμФ
 */
LOCAL_INLINE uint8
uart_getchar(void)
{
	return((uint8) sil_rew_iop((void *) UART_RXDATA));
}

/*
 *  
 */
void
InitHwSerial(void)
{
	/*
	 *  ߵ
	 */
	sil_wrw_iop((void *) UART_CONTROL,
				sil_rew_iop((void *) (UART_CONTROL))
				| UART_CONTROL_IRRDY);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
TermHwSerial(void)
{
	/*
	 * ߤζػ
	 */
	sil_wrw_iop((void *) UART_CONTROL,
				sil_rew_iop((void *) (UART_CONTROL))
				& (~UART_CONTROL_IRRDY));
}

/*
 *  SIOγߥϥɥ
 */
ISR(RxHwSerialInt)
{
	if (uart_getready() != FALSE) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		RxSerialInt(uart_getchar());
	}
}
