/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: vic.h 6835 2013-01-23 10:11:15Z fsi-dankei $
 */

/*
 *		VICɥ饤
 */

#ifndef TOPPERS_VIC_H
#define TOPPERS_VIC_H

#include "prc_sil.h"

/*
 *  ٥ߥȥ(VIC)
 */
#define VIC_INT_CONFIG(n)       (VIC_BASE + ((uint32) (n) << 2))
#define VIC_INT_ENABLE          (VIC_BASE + 0x80U)
#define VIC_INT_ENABLE_SET      (VIC_BASE + 0x84U)
#define VIC_INT_ENABLE_CLR      (VIC_BASE + 0x88U)
#define VIC_INT_PENDING         (VIC_BASE + 0x8cU)
#define VIC_INT_RAW_STATUS      (VIC_BASE + 0x90U)
#define VIC_SW_INTERRUPT        (VIC_BASE + 0x94U)
#define VIC_SW_INTERRUPT_SET    (VIC_BASE + 0x98U)
#define VIC_SW_INTERRUPT_CLR    (VIC_BASE + 0x9cU)
#define VIC_VIC_CONFIG          (VIC_BASE + 0xa0U)
#define VIC_VIC_STATUS          (VIC_BASE + 0xa4U)
#define VIC_VEC_TBL_BASE        (VIC_BASE + 0xa8U)
#define VIC_VEC_TBL_ADDR        (VIC_BASE + 0xacU)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ٥ơ֥(Os_Lcfg.c)
 */
extern void kernel_vectors(void);

/*
 *  VICεư
 *
 *  VICŪʥ޳׵ȯ
 */
extern void vic_initialize(void);

/*
 *  Ƴߤ
 */
LOCAL_INLINE void
vic_set_int_config(uint8 intno, uint32 config)
{
	sil_wrw_iop((void *) VIC_INT_CONFIG(intno), config);
}

/*
 *  Ƴߤ
 */
LOCAL_INLINE uint32
vic_get_int_config(uint8 intno)
{
	return(sil_rew_iop((void *) VIC_INT_CONFIG(intno)));
}

/*
 *  ٥ơ֥Υ١ɥ쥹
 */
LOCAL_INLINE void
vic_set_vec_tbl_base(uint32 base)
{
	sil_wrw_iop((void *) VIC_VEC_TBL_BASE, base);
}

/*
 *  ꤵ줿׵Ĥ
 */
LOCAL_INLINE void
vic_set_int_enable(uint32 enable_set)
{
	sil_wrw_iop((void *) VIC_INT_ENABLE_SET, enable_set);
}

/*
 *  ꤵ줿׵ػߤ
 */
LOCAL_INLINE void
vic_clr_int_enable(uint32 enable_clr)
{
	sil_wrw_iop((void *) VIC_INT_ENABLE_CLR, enable_clr);
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_VIC_H */
