/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: task.h 6835 2013-01-23 10:11:15Z fsi-dankei $
 */

/*
 *		ǽ
 */

#ifndef TOPPERS_TASK_H
#define TOPPERS_TASK_H

#include "queue.h"
#include "resource.h"

/*
 *  ٥ȥޥͤ
 */
#define EVTMASK_NONE	((EventMaskType) 0) /* ٥Ȥʤ */

/*
 *  ͥ٤ϰϡʳɽ
 */
#define TMIN_TPRI		UINT_C(0)       /* ͥ٤κǾ͡ʺ͡*/
#define TMAX_TPRI		UINT_C(15)      /* ͥ٤κ͡ʺǹ͡*/

/*
 *  ͥ٤ʳ
 */
#define TNUM_TPRI		((TMAX_TPRI - TMIN_TPRI) + 1U)

/*
 *  ͥͤɽ
 */
#define TPRI_MINTASK	((PriorityType) (TNUM_TPRI - 1U))               /* 㥿ͥ */
#define TPRI_MAXTASK	((PriorityType) (0))                            /* ǹ⥿ͥ */

/*
 *  IDTCBФΥޥ
 */
#define get_tcb(tskid)		(&(tcb_table[(tskid)]))

/*
 *  TCB饿IDФΥޥ
 *  p_tcb NULLξϻȤʤ
 */
#define	TSKID(p_tcb)	((TaskType) ((p_tcb) - tcb_table))

#ifndef OMIT_BITMAP_SEARCH
#define	BITMAP_NUM		15       /* bitmap_search_tableΥ */
#endif /* OMIT_BITMAP_SEARCH */

/*
 *  ݻѿOs_Lcfg.c
 */
extern const TaskType	tnum_task;          /* ο */
extern const TaskType	tnum_exttask;       /* ĥο */


/*
 *  ֥å
 *
 *  ˴ؤͤѤʤROM֤ʬʥ
 *  ֥åˤȡͤѲ뤿RAM֤ʤФʤʤ
 *  ʬʥ֥åTCBˤʬΥTCBб륿
 *  ֥åؤݥ󥿤
 *  ֥åбTCBؤݥ󥿤ˡ
 *  RAMδ˾ޤ¹ԸΨʤ뤿˺
 *  Ƥʤ
 *  ¾Υ֥ȤˤĤƤƱͤ˰
 */
typedef struct task_initialization_block {
	FunctionRefType	task;       /* εư */

#ifdef USE_TSKINICTXB
	TSKINICTXB tskinictxb;           /* ƥȥ֥å */
#else /* USE_TSKINICTXB */
	MemorySizeType	stksz;              /* åΰΥʴݤ᤿͡ */
	void			*stk;               /* åΰƬ */
#endif /* USE_TSKINICTXB */

	PriorityType	inipri;         /* ͥ ɽ*/
	PriorityType	exepri;         /* ¹Գϻͥ ɽ*/
	uint8			maxact;         /* ¿ŵư׵κ */
	AppModeType		autoact;        /* ư⡼ */
} TINIB;

/*
 *  ֥åOs_Lcfg.c
 */
typedef struct task_control_block {
	QUEUE			task_queue;     /* 塼(¤ΤƬɬ) */
	const TINIB		*p_tinib;       /* ֥åؤΥݥ */
	PriorityType	curpri;         /* ߤͥ١ɽ*/
	TaskStateType	tstat;          /* ֡ɽ*/
	uint8			actcnt;         /* ¿ŵư׵ */
	EventMaskType	curevt;         /* ٥Ȥθ */
	EventMaskType	waievt;         /* ԤäƤ륤٥ */
	RESCB			*p_lastrescb;   /* Ǹ˳꥽֥åؤΥݥ */
	TSKCTXB			tskctxb;        /* ƥȥ֥å */
} TCB;

/*
 *  ¹Ծ֤Υ
 *
 *  ¹Ծ֤ΥʤˤϡNULL ˤ
 */
extern TCB			*p_runtsk;

/*
 *  ǹ̥ͥ
 *
 *  ¹ϡruntsk Ȱפ
 *  ¹ԤǤ֡ʼ¹Ծ֤ޤϼ¹Բǽ֡ˤΥʤˤϡ
 *  NULL ˤ
 */
extern TCB			*p_schedtsk;

/*
 *  ǥ塼κǹͥ
 *
 *  ǥ塼ˤϼ¹Բǽ֤ΥΤߤޤΤǡ¹Բǽ֤
 *  Ǥκǹͥ٤ݻ
 *  ǥ塼λʼ¹Բǽ֤Υ̵ˤ TPRI_MINTASKˤ
 */
extern PriorityType nextpri;

/*
 *  ǥ塼
 *
 *  ǥ塼ϡ¹ԤǤ֤Υ뤿Υ塼Ǥ
 *  ǥ塼ϡͥ٤ȤΥ塼ǹƤ
 *  TCBϡͥ٤Υ塼Ͽ
 */
extern QUEUE		ready_queue[TNUM_TPRI];

/*
 *  ǥ塼ΤΥӥåȥޥå
 *
 *  ǥ塼ΥΨ褯Ԥˡͥ٤ȤΥ塼
 *  ˥äƤ뤫ɤ򼨤ӥåȥޥåפѰդƤ
 *  ӥåȥޥåפȤȤǡꥢβ򸺤餹ȤǤ뤬
 *  ӥå̿᤬¤Ƥʤץåǡͥ٤ʳʤ
 *  ˤϡӥåȥޥåΥСإåɤΤˡդ˸Ψ
 *  ǽ⤢
 *
 *  ͥ٤16ʳǤ뤳ȤꤷƤ뤿ᡤuint16ȤƤ
 */
extern uint16		ready_primap;

/*
 *  ֥åΥꥢOs_Lcfg.c
 */
extern const TINIB	tinib_table[];

/*
 *  TCBΥꥢOs_Lcfg.c
 */
extern TCB			tcb_table[];

/*
 *  ⥸塼ν
 */
extern void	task_initialize(void);

/*
 *  εư
 *
 *  оݥp_tcbǻꤷˤư
 *  ʵٻ߾֤¹ԤǤ֤ܤ
 *  εưɬפʽԤ
 */
extern boolean	make_active(TCB *p_tcb);

/*
 *  ¹ԤǤ֤ؤΰܹ
 *
 *  оݥp_tcbǻꤷˤ¹ԤǤ֤ܤ
 *  оݥͥ٤ǹͥ٥schedtskˤͥ٤
 *  ˤϡоݥ򿷤ǹͥ٥ȤޤǤκǹ
 *  ͥ٥ǥ塼Ƭ
 *  Ǥʤˤϡоݥǥ塼
 *  оݥǹͥ٥ȤˡTRUE ֤
 */
extern boolean	make_runnable(TCB *p_tcb);

/*
 *  ¹ԤǤ֤¾ξ֤ؤ
 */
extern void	make_non_runnable(void);

/*
 *  ǹ̥ͥΥ
 *
 *  ǥ塼κǹ̤ͥΥ򥵡
 *  ǥ塼ξˤϡδؿƤӽФƤϤʤʤ
 */
extern void	search_schedtsk(void);

/*
 *  Υץꥨץ
 *
 *  ¹Բǽ֤˰ܹԤǹͥ٥¹Ծ֤ˤ
 *  δؿäˡdispatch ƤӽФ¾Υڤؤ
 *  ȤꤷƤ
 */
extern void	preempt(void);

/*
 *  ¹ΥSUSPENDED֤ˤ
 */
extern void suspend(void);

/*
 *  ꥽
 */
extern void release_taskresources(TCB *p_tcb);

/*
 *  λѥεư
 *
 *  OS߶ػ߾֤ǸƤФ
 */
extern void activate_task_action(TaskType TaskID);

/*
 *  λѥ٥ȤΥå
 *
 *  OS߶ػ߾֤ǸƤФ
 */
extern void set_event_action(TaskType TaskID, EventMaskType Mask);

/*
 *  λ˸Ƥִؿ
 */
extern void exit_task(void);

#endif /* TOPPERS_TASK_H_ */
